{{Throttle.spin
This object is for Electrifly SS-35 to initialize and control throttle settings for aircraft.

FullBrake = 100 or 1ms
FullThrottle = 220 or 2.2ms

Calibrating the ESC: apply full brake and pause for 1/2 a second, apply full throttle
and pause for another 1/2 second, and lastly bringing it back to full brake and pause for 1/2 a
second.
}}
CON
   pin          = 4

OBJ
  debug :       "FullDuplexSerialPlus"   
VAR
  long tC, tHa, t
  long stack[80]        'stack space for ESC
  byte cog

PUB main
  debug.start(31, 30, 0, 115200) 
PUB Start(pulseWidth) : success
  success := (cog := cognew(throttleData(pulseWidth), @stack) + 1)
  
PUB throttleData(pulseWidth) | pulse, oldPulse

  pulse := long[pulseWidth]
  oldPulse := pulse

  repeat
    pulse := long[pulseWidth]
    throttle(pulse)
    debug.Str(String(10, 13))
    debug.Dec(pulse)

    if pulse <> oldPulse
      throttle(oldPulse)
    oldPulse := pulse

PUB initialize
  fullBrake                                       'Fullbrake
  Delay(500)                                      'Delay 500 mS
  fullThrottle                                    'Fullthrottle
  Delay(500)                                      'Delay 500 mS
  fullBrake                                       'Fullbrake
  Delay(500)

PRI throttle(pulseWidth)
  ctra[30..26] := %00100                                'Configure counter A to NCO mode
  ctra[8..0] := pin
  frqa := 1
  dira[pin]~~

  tC := ((clkfreq/ 100_000) * 2000)
  tHa := ((clkfreq/ 100_000) * pulseWidth)
  t := cnt

  repeat
    phsa := -tHa
    t += tC
    waitcnt (t)

PRI fullBrake
  ctra[30..26] := %00100                                'Configure counter A to NCO mode
  ctra[8..0] := pin
  frqa := 1
  dira[4]~~

  tC := ((clkfreq/ 100_000) * 2000)                     ' Set up cycle and high times 20ms
  tHa := ((clkfreq/ 100_000) * 100)                     ' 1.0ms pulse
  t := cnt                                              'Mark counter time
  
  repeat 150
    phsa := -tHa                                        ' Set up the pulse
    t += tC                                             ' Calculate next cycle repeat
    waitcnt(t)
       
PRI fullThrottle
  ctra[30..26] := %00100                                'Configure counter A to NCO mode
  ctra[8..0] := pin
  frqa := 1
  dira[4]~~

  tC := ((clkfreq/ 100_000) * 2000)                     ' Set up cycle and high times 20ms
  tHa := ((clkfreq/ 100_000) * 220)                    ' 2.2ms pulse
  t := cnt                                              'Mark counter time
  
  repeat 150
    phsa := -tHa                                        ' Set up the pulse
    t += tC                                             ' Calculate next cycle repeat
    waitcnt(t)
    
PRI Delay(mS)
  waitcnt((clkfreq / 1000 * mS) + cnt)